// author Henrik Hedman
// may 2005

public class List //implements List
{
	
	//data members
	private Node head; 
	
	//constructor
	public List()
	{
		head = new Node();
	}
	
	//return head
	public Node getHead() {
		return head;
	}
	
	//Remove all items from the list
	public void makeEmpty()
	{
		head.next = null;
	}
	
	//Return true if the list is empty; 
	//otherwise return false
	public boolean isEmpty()
	{
		return head.next == null;
	}
	
	//Return true if x belongs to the list; 
	//otherwise return false
	public boolean find(int x, int y)
	{
		Node p = head;
		
		while(p.next != null && (x != p.elementx || y != p.elementy)) {
			p = p.next;
			if(p.elementx == -1 || p.elementy == -1)
				break;
		}
		return (x == p.elementx && y == p.elementy);
	}
	//make a duplicate list
	public static List copy(Node p) {
		
		List tempL = new List();
		
		while(p.next != null) {
			tempL.insert(p.next);
			p = p.next;
		}
		return tempL;
	}
	
	//Insert a node into list
	public void insert(Node p)
	{
		head.next = new Node(p.elementx, p.elementy, head.next);
	}
	//Insert x,y at the head of the list
	public boolean insert(int x, int y)
	{
		if(head.next == null) {
			head.next = new Node(x,y,head.next);
			return true;
		}
		if(!(head.next.elementx == x && head.next.elementy == y || x == -1 || y == -1)) {
			head.next = new Node(x,y,head.next);
			return true;
		}
		return false;
	}
	
	//Remove x,y from the list. 
	public void remove()
	{
		if(isEmpty())
		{
			//			System.out.println("empty");
		}
		else
		{
			head.next = head.next.next;
		}
	}
	
	//Remove x, y from the list. 
	//If x & y belongs to the list then returns true; 
	//otherwise, return false
	public boolean remove(int x, int y)
	{
		Node p = head;
		
		while(p.next != null && (x != p.next.elementx || y != p.next.elementy)) {
			//			System.out.println(p.next.elementx + " " + p.next.elementy);
			p = p.next;
			
			/* 		if(p.elementx == x && p.elementy == y)
			break;
			if(p.elementx == -1 || p.elementy == -1)
				break; */
		}
		
		if(p.next != null) //x == p.elementx && y == p.elementy)
		{
			p.next = p.next.next;
			//			System.out.println("remove: "+x+", "+y);
			return true;
		}
		
		//	System.out.println("Not in open list ("+x+ ","+y+ ")"); 
		return false;
	}
	
	// Return the length of the list 
	public int length()
	{
		Node p = head;
		int antal=0;
		while(p.next != null)
		{
			p = p.next;
			antal++;
		}
		return antal;
	}
	
	//returns the x-value
	public int getX()
	{
		return head.next.elementx;
	}
	
	//returns the y-value
	public int getY()
	{
		return head.next.elementy;
	}
	
	// Print all items in the list on the standard output stream
	public void print()
	{
		if (!isEmpty())
		{
			Node p = head.next;
			while (p != null) {
				System.out.print(p.elementx + ", " + p.elementy + " -> ");
				p = p.next;
			}
			System.out.println(""/*length()*/);
		}
		else
			System.out.println("Empty");
	}
}

//The Nodes
class Node
{
	// data members
	public int elementx, elementy;
	Node next, prev; //link to the node after and before
	
	// constructors
	Node()
	{ this(-1, -1, null); }
	
	// Ska lÃ¤gga till sÃ¥ att man har en fÃ¶rÃ¤lder!  Node(int e, int par, Node p, Node n) int parent = par
	Node (int x, int y, Node n)
	{ elementx = x; elementy = y; next = n; }
}
