/*******************************************************************************
 * 
 * Classname: 	Zone 
 * Properties: 	Contains the basic information of one square of the battlefield
 * Superclass: 	Object 
 * Author: 		Anders Fjeldstad
 *  
 ******************************************************************************/

import javax.swing.*;

public class Zone {
	private int type = 0; //Describes the type of square: 0 = Open, 1 = Wall, 2 = tested, 3 = start, 4 = path
	
	private JLabel label;
	
	private ImageIcon[] pics;
	
	private int parentX;
	
	private int parentY;
	
	private int H; //distance (heuristic) to goal
	
	private int G; //zones walked
	
	private int F; //F = G + H
	/*
	 * Methodname: Zone() (Constructor) 
	 * Purpose: Initiates and returns an object of type Zone 
	 * Parameters: p (An array of type ImageIcon) 
	 * Returns: An object of type Zone
	 */
	public Zone(ImageIcon[] p) {
		label = new JLabel();
		label.setHorizontalAlignment(JLabel.LEFT);
		label.setVerticalAlignment(JLabel.TOP);
		pics = p;
		label.setIcon(pics[0]); //Set the current icon to the empty, walkable
		// zone
		type = 0;
	}
	
	/*
	 * Methodname: 	setH 
	 * Purpose:		sets the distance (H) to the goal 
	 * Parameters: 	-
	 * Returns: 	-
	 */
	public void setH(int d) {
		H = d;
	}
	
	public int getH() {
		return H;
	}
	
	public void setG(int g) {
		G = g;
	}
	
	public int getG() {
		return G;
	}
	
	public int getF() {
		return G + H;
	}
	
	/*
	 * Methodname: 	setParent 
	 * Purpose: 	save the parent zone 
	 * Parameters: 	x - the x position 
	 * 				y - the y position Returns: -
	 */
	public void setParent(int x, int y) {
		parentX = x;
		parentY = y;
	}
	
	public int getParentX() {
		return parentX;
	}
	
	public int getParentY() {
		return parentY;
	}
	
	/*
	 * Methodname: setType 
	 * Purpose: set its label to display the correct picture
	 * Parameters: - 
	 * Returns: -
	 */
	public void setType(int t) {
		type = t;
		//		label.setIcon(pics[t]);
	}
	
	//set label (picture)
	public void setLabel(int t) {
		label.setIcon(pics[t]);
	}
	
	// set open
	public void unmark() {
		type = 0;
	}
	
	// get label (picture)
	public JLabel get_label() {
		return label;
	}
	
	// get type (open, wall ...)
	public int getType() {
		return type;
	}
}
